﻿class Tile {
	var column:Number, row:Number;
	var whiteHot:Boolean = false;
	var blackHot:Boolean = false;
	var filled:Boolean = false;
	var justCaptured:Boolean = false;
	var chessPiece, capturedPiece;
	var whiteThreats:Array = new Array();
	var blackThreats:Array = new Array();
	function Tile(x:Number, y:Number) {
		//constructor
		column = x;
		row = y;
		whiteThreats = new Array();
		blackThreats = new Array();
	}
	function pawnCheck(col:String):Boolean {
		var returnVal:Boolean = true;
		var threats:Array;
		if (col == "white") {
			threats = getWhiteThreats();
		} else {
			threats = getBlackThreats();
		}
		if (threats.length == 1) {
			var tmp_piece:ChessPiece = threats[0];
			if (tmp_piece.getType() == "pawn" && getColumn() == tmp_piece.getTile().getColumn()) {
				returnVal = false;
			}
		}
		return returnVal;
	}
	function getColumn():Number {
		return column;
	}
	function getRow():Number {
		return row;
	}
	function getCapturedPieceID():String {
		return capturedPiece.getID();
	}
	function removeCapturedPiece():Boolean {
		if (justCaptured) {
			capturedPiece.clearTileThreats();
			capturedPiece.removeClip();
			delete capturedPiece;
			return true;
		}
		return false;
	}
	function unCapturePiece() {
		if (justCaptured) {
			chessPiece = capturedPiece;
			chessPiece.setAlive(true);
			filled = true;
			justCaptured = false;
			delete capturedPiece;
		}
	}
	function capturePiece() {
		chessPiece.setAlive(false);
		capturedPiece = chessPiece;
		justCaptured = true;
	}
	function addPiece(thePiece:ChessPiece) {
		if (filled) {
			capturePiece();
		} else {
			delete capturedPiece;
			justCaptured = false;
			filled = true;
		}
		chessPiece = thePiece;
		thePiece.addTile(this);
	}
	function removePiece() {
		filled = false;
		delete chessPiece;
	}
	function getCapturedPiece():ChessPiece {
		return capturedPiece;
	}
	function addThreatPiece(thePiece:ChessPiece) {
		var color:String = thePiece.getColor();
		if (color == "white") {
			whiteHot = true;
			whiteThreats.push(thePiece);
		} else if (color == "black") {
			blackHot = true;
			blackThreats.push(thePiece);
		}
	}
	function getWhiteThreats():Array {
		return whiteThreats;
	}
	function getBlackThreats():Array {
		return blackThreats;
	}
	function removeThreatPiece(thePiece:ChessPiece) {
		var color:String = thePiece.getColor();
		var arr:Array;
		if (color == "white") {
			arr = whiteThreats;
		} else if (color == "black") {
			arr = blackThreats;
		}
		for (var i = 0; i<arr.length; ++i) {
			if (arr[i] == thePiece) {
				arr.splice(i, 1);
				break;
			}
		}
		if (color == "white") {
			if (whiteThreats.length == 0) {
				whiteHot = false;
			}
		} else if (color == "black") {
			if (blackThreats.length == 0) {
				blackHot = false;
			}
		}
	}
	function getPiece():ChessPiece {
		return chessPiece;
	}
	function get isWhiteHot():Boolean {
		return whiteHot;
	}
	function get isBlackHot():Boolean {
		return blackHot;
	}
	function get isFilled():Boolean {
		return filled;
	}
}
