﻿var path;
var maxConnected;
function pluginInit(hash) {
	//This method is called when the room starts
	trace("----AdminPlugin Initialized----");
	maxConnected = 0;
	setInterval("run", 500);
}
function run() {
	var helper = Plugin.getPluginHelper();
	/*
	var totalMemory = helper.getMemoryStatistics();
	trace("----")
	trace(totalMemory[0])
	trace(totalMemory[1])
	trace(totalMemory[2])*/
	
	var num = getLoggedInUserCount();
	if (num> maxConnected) {
		maxConnected = num;
		trace("Max connected: "+maxConnected);
	}
}
function pluginRequest(hash) {
	var caller = hash.get("ExecutingUserName");
	var method = hash.get("Method");
	if (method == "GetZonesAndRooms") {
		inspectServer(caller);
	} else if (method == "GetRoomInfo") {
		inspectRoom(caller, hash.get("zone"), hash.get("room"));
	} else if (method == "kick") {
		kick(hash.get("name"));
	} else if (method == "ban") {
		ban(hash.get("name"), 100000);
	} else if (method == "GetBasicStats") {
		getBasicStats(caller);
	}
}
function getBasicStats(caller) {
	var numConnected = getLoggedInUserCount();
	var zones = getAllZones();
	var numZones = zones.length;
	var numRooms = 0;
	for (var i=0;i<zones.length;++i) {
		var zone = zones[i];
		var rooms = getRoomsInZone(zone.Name);
		if (rooms != null) {
			numRooms += rooms.length;
		}
	}
	server.sendMessage("private", [caller], "BasicStats", {maxConnected:maxConnected, numConnected:numConnected, numZones:numZones, numRooms:numRooms});
}
function inspectRoom(caller, zone, room) {
	var content = "";
	var roomVars = getRoomVariables2(zone, room);
	for (var i = 0; i<roomVars.length; ++i) {
		var roomVar = roomVars[i];
		var varName = roomVar.name
		var value = roomVar.value
		var locked = roomVar.locked
		var persistent = roomVar.persistent;
		content += varName+","+value+","+locked+","+persistent;
		if (i != roomVars.length-1) {
			content += "|||";
		}
	}
	content += "^^^";
	var users = getUsersInRoom2(zone, room);
	for (var k=0;k<users.length;++k) {
		var user = users[k];
		var userVars = getUserVariables(user.Name);
		if (userVars != null) {
			content += user.Name;
			//var userVars = hashToObject(Plugin.getPluginHelper().getUserVariablesAsMap(user.Name.toString()));
			//var userVars = hashToObject(Plugin.getPluginHelper().getUserVariablesAsMap("jobe"));
			var firstOne = true;
			//for (var i in userVars) {
			for (var i = 0; i<userVars.length; ++i) {
				if (firstOne) {
					firstOne = false;
					content += "~~~";
				}
				var userVar = userVars[i];
				var varName = userVar.name;
				var varValue = userVar.value;
				//var varName = i;
				//var varValue = userVars[i];
				content += varName+"***"+varValue;
				if (i != userVars.length-1) {
					content += "|||";
				}
			}
		}
		if (k != users.length-1) {
			content += "###";
		}
	}
	server.sendMessage("private", [caller], "RoomInfo", {content:content, room:room, zone:zone});
}
function getUsersInRoom2(zone, room) {
	var results = new Array();
	var helper = Plugin.getPluginHelper();
	var users = helper.getUsersInRoom(zone, room);
	if (users != null) {
		for (var i=0;i<users.length;++i) {
			var user = users[i];
			results.push({Name:user.getName()});
		}
	}
	return results;
}

function getRoomVariables2(zoneName, roomName) {
	var helper = Plugin.getPluginHelper();
	if (zoneName == undefined || roomName == undefined) {
		zoneName = helper.getZoneName();
		roomName = helper.getRoomName();
	}
	var roomVars = helper.getRoomVariables(zoneName, roomName);
	var arr = new Array();
	if (roomVars != null) {
		for (var i = 0; i<roomVars.length; ++i) {
			var ob = new Object();
			var roomVar = roomVars[i];
			ob.name = roomVar.getName();
			ob.value = roomVar.getValue();
			ob.locked = roomVar.isLocked();
			ob.persistent = roomVar.isPersistent();
			arr.push(ob);
		}
	}
	return arr;
}

function inspectServer(caller) {
	//Just showing how to get the list of zones, and get the rooms per zone
	var content = "";
	var zones = getAllZones();
	var allUsers = new Array();
	for (var i=0;i<zones.length;++i) {
		var zone = zones[i];
		var rooms = getRoomsInZone(zone.Name);
		content += "<Zone label='"+zone.Name+"'>";
		for (var j=0;j<rooms.length;++j) {
			var room = rooms[j];
			var users = getUsersInRoom(zone.Name, room.Name);
			var ulen = users.length;
			content += "<Room label='"+room.Name+" - ("+ulen+")' room='"+room.Name+"' zone='"+zone.Name+"' hidden='"+room.hidden+"'/>";
			/*content += "<Users>";
			for (var k=0;k<users.length;++k) {
				var user = users[k];
				allUsers.push(user);
				content += "<User><Name>"+user.Name+"</Name></User>";
			}
			content += "</Users>";
			*/
			//content += "</Room>";
		}
		content += "</Zone>";
	}
	content = "<![CDATA[<Server label='Zones'>"+content+"</Server>]]>";
	server.sendMessage("private", [caller], "ZonesAndRooms", {content:content});
	//writeFile(path, content, false);
}