﻿/*
Watch out for:
-case sensitivity
-can't use something that has not yet been defined
-setInterval needs a string for a function instead of a reference: setInterval("myFunc", 300)
*/
/*
=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~
:::Helper objects written to extend the server-side scripting ability to include
   some essential functionality that Flash programmers are used to. This included
   setInterval, loadVariables, random(), trace():::

Author: Jobe Makar, Electrotank
Email: jobe@electrotank.com
=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~
*/
function trace(info) {
	if (info != null) {
		out.println(info);
	} else {
		var error = "Error attempting to trace: No content was passed in.";
		logger.warning(error);
	}
}
function sendRawMessage(type, msg, users) {
	var helper = Plugin.getPluginHelper();
	if (type == "public") {
		helper.sendRawPublicMessage(msg);
	} else if (type == "private") {
		for (var i=0;i<users.length;++i) {
			helper.sendRawPrivateMessage(users[i], msg)
		}
	}
}
function getPluginName() {
	return Plugin.getPluginHelper().getName()
}
function getLoggedInUserCount() {
	return Plugin.getPluginHelper().getLoggedInUserCount();
}
function getServerTimer() {
	return Plugin.getPluginHelper().getServerTime();
}
function callRemotePlugin(pluginName, hash) {
	return Plugin.getPluginHelper().callRemotePlugin(pluginName, hash);
}
function setUserServerVariable(username, name, value) {
	Plugin.getPluginHelper().setUserServerVariable(username, name, value);
}
function getUserServerVariable(username, name) {
	return Plugin.getPluginHelper().setUserServerVariable(username, name);
}
function removeUserServerVariable(username, name) {
	Plugin.getPluginHelper().removeUserServerVariable(username, name);
}
function kick(username) {
	Plugin.getPluginHelper().kick(username);
}
function ban(username, time) {
	Plugin.getPluginHelper().ban(username, time);
}
function objectToHash(ob) {
	var hash = new java.util.HashMap();
	for (var i in ob) {
		hash.put(i, ob[i]);				
	}
	return hash;
}
function hashToObject(hash) {
	var set = hash.keySet();
	var iterator = set.iterator();
	var ob = new Object();
	while(iterator.hasNext()) {
		var tempName = iterator.next();
		var tempValue = hash.get(tempName);
		ob[tempName] = tempValue;
	}
	return ob;
}
function serverAS() {
}
serverAS.prototype.sendMessage = function(type, one, two, three) {
	if (type == "public") {
		var what = one;
		if (what != null) {
			var ob = two;
			var variables = "";
			var hash = new java.util.HashMap();
			for (var i in ob) {
				//variables += "<Variable><Name>"+i+"</Name><Data>"+ob[i]+"</Data></Variable>";
				hash.put(i, ob[i]);				
			}
			var helper = Plugin.getPluginHelper();
			helper.sendPublicMessage(what, hash);
		} else {
			var error = "Error trying to send a public message from a plugin: There was no message.";
			logger.warning(error);
			trace(error);
		}
	} else if (type == "server") {
		var what = one;
		if (what != null) {
			var ob = two;
			var variables = "";
			var hash = new java.util.HashMap();
			for (var i in ob) {
				//variables += "<Variable><Name>"+i+"</Name><Data>"+ob[i]+"</Data></Variable>";
				hash.put(i, ob[i]);				
			}
			var helper = Plugin.getPluginHelper();
			helper.sendPublicMessageToServer(what, hash);
		} else {
			var error = "Error trying to send a public message from a plugin: There was no message.";
			logger.warning(error);
			trace(error);
		}
	} else if (type == "zone") {
		var what = two;
		if (what != null) {
			var ob = three;
			var variables = "";
			var hash = new java.util.HashMap();
			var zone = one;
			for (var i in ob) {
				//variables += "<Variable><Name>"+i+"</Name><Data>"+ob[i]+"</Data></Variable>";
				hash.put(i, ob[i]);
			}
			var helper = Plugin.getPluginHelper();
			helper.sendPublicMessageToZone(zone, what, hash);
		} else {
			var error = "Error trying to send a public message from a plugin: There was no message.";
			logger.warning(error);
			trace(error);
		}
	}else if (type == "private") {
		var what = two;
		var users = one;
		if (what != null && users instanceof Array) {
			var ob = three;
			//var variables = "";
			var hash = new java.util.HashMap();
			for (var i in ob) {
				//variables += "<Variable><Name>"+i+"</Name><Data>"+ob[i]+"</Data></Variable>";
				hash.put(i, ob[i]);
			}
			var helper = Plugin.getPluginHelper();
			for (var i=0;i<users.length;++i) {
				helper.sendPrivateMessage(users[i], what, hash);
			}
		} else {
			var error = "Error trying to send a private message from a plugin:";
			if (what == null) {
				error += " There was no message.";
			}
			if (!users instanceof Array) {
				error += " An array of users was not passed in.";
			}
			logger.warning(error);
			trace(typeof users);
			trace(error);
		}
	}
};
serverAS.prototype.moveToRoom = function(who, zoneName, roomName, password, numbered) {
	if (password == undefined) {
		password = "";
	}
	if (numbered == undefined) {
		numbered = false;
	}
	//result codes: JOIN_SUCCESSFUL = 0, ZONE_DOESNT_EXIST = , ROOM_DOESNT_EXIST = 2, INVALID_ROOM_PASSWORD = 3, ROOM_FULL = 4, USER_DOESNT_EXIST = 5;
	return Plugin.getPluginHelper().moveToRoom(who, zoneName, roomName, password, numbered);
}
serverAS.prototype.createRoom = function(roomOb) {
	var action = "CreateRoom";
	var password = roomOb.password;
	var UserVariablesEnabled = roomOb.userVariablesEnabled;
	var hidden = roomOb.hidden;
	var zoneName = roomOb.zone;
	var roomName = roomOb.roomName;
	var numbered = roomOb.numbered;
	var capacity = roomOb.capacity;
	var description = roomOb.description;
	var roomVariables = roomOb.roomVariables;
	var updatable = roomOb.updatable;
	var plugins = roomOb.plugins;
	var FloodingFilterEnabled = roomOb.FloodingFilterEnabled;
	var userListEnabled = roomOb.userListEnabled;
	var descOb = new Object();
	if (userListEnabled == undefined) {
		userListEnabled = true;
	}
	if (description == undefined) {
		description = roomOb.Description;
		if (description == undefined) {
			description = "";
		}
	}
	if (FloodingFilterEnabled == undefined) {
		FloodingFilterEnabled = false;
	}
	descOb.description = description;
	if (roomOb.attributes != undefined) {
		descOb.attributes = roomOb.attributes;
	}
	var descXML = "";
	if (zoneName == undefined) {
		zoneName = "Chat Area";
	}
	if (updatable == undefined) {
		updatable = true;
	}
	if (hidden == undefined) {
		hidden = false;
	}
	if (capacity == undefined) {
		capacity = -1;
	}
	if (numbered == undefined) {
		numbered = false;
	}
	if (password == undefined) {
		password = "";
	}
	if (UserVariablesEnabled == undefined) {
		UserVariablesEnabled = false;
	}
	if (roomVariables == undefined) {
		var roomVariableXML = "<RoomVariables/>";
	} else {
		var roomVariableXML = "<RoomVariables>";
		for (var i = 0; i<roomVariables.length; ++i) {
			var ob = roomVariables[i];
			var persistent = ob.persistent;
			var locked = ob.locked;
			var name = ob.name;
			var data = ob.data;
			if (persistent == undefined) {
				persistent = false;
			}
			if (locked == undefined) {
				locked = false;
			}
			var str = "<RoomVariable Persistent='"+persistent+"' Locked='"+locked+"'>";
			str += "<Name>"+name+"</Name>";
			str += "<Data><![CDATA["+data+"]]></Data>";
			str += "</RoomVariable>";
			roomVariableXML += str;
		}
		roomVariableXML += "</RoomVariables>";
	}
	if (plugins == undefined) {
		var pluginXML = "<Plugins />";
	} else {
		var pluginXML = "<Plugins>";
		for (var i = 0; i<plugins.length; ++i) {
			var plugin = plugins[i];
			var name = plugin.name;
			var pluginVariables = plugin.variables;
			if (pluginVariables == undefined) {
				var pluginVariablesXML = "<Variables />";
			} else {
				var pluginVariablesXML = "<Variables>";
				for (var j in pluginVariables) {
					var pluginVarValue = pluginVariables[j];
					pluginVariablesXML += "<Variable><Name>"+j+"</Name><Value>"+pluginVarValue+"</Value></Variable>";
				}
				pluginVariablesXML += "</Variables>";
			}
			pluginXML += "<Plugin><Name>"+name+"</Name>"+pluginVariablesXML+"</Plugin>";
		}
		pluginXML += "</Plugins>";
	}
	var parameters = "<Zone><Name>"+zoneName+"</Name><Room UserListEnabled='"+userListEnabled+"' Updatable='"+updatable+"' Hidden='"+hidden+"' FloodingFilterEnabled='"+FloodingFilterEnabled+"' Numbered='"+numbered+"' UserVariablesEnabled='"+UserVariablesEnabled+"'><Name>"+roomName+"</Name><Password>"+password+"</Password><Description><![CDATA["+descXML+"]]></Description><Capacity>"+capacity+"</Capacity>"+roomVariableXML+pluginXML+"</Room></Zone>";
	var message = "<XmlDoc><Action>"+action+"</Action><Parameters>"+parameters+"</Parameters></XmlDoc>";
	var resultCode = Plugin.getPluginHelper().createRoom(message);
	//result codes: CREATE_SUCCESSFUL = 0, INVALID_PARAMETERS = 1, ROOM_ALREADY_EXISTS = 2, FAILED_CREATING_ROOM = 3;
	return resultCode;
}

function loggerAS() {
}
loggerAS.prototype.severe = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.severe(info);
	}
};
loggerAS.prototype.info = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.info(info);
	}
};
loggerAS.prototype.warning = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.warning(info);
	}
};
loggerAS.prototype.config = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.config(info);
	}
};
loggerAS.prototype.fine = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.fine(info);
	}
};
loggerAS.prototype.finer = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.finer(info);
	}
};
loggerAS.prototype.finest = function(info) {
	if (info != null) {
		var helper = Plugin.getPluginHelper();
		helper.finest(info);
	}
};
function setInterval(functionName, interval) {
	if (typeof functionName == "string" && typeof interval == "number") {
		return Plugin.setInterval(functionName, interval, interval);
	} else {
		var error = "Error creating setInterval:";
		if (typeof functionName != "string") {
			error += "  FunctionName parameter was not a string.";
		}
		if (typeof interval != "number") {
			error += "  Interval parameter was not a number.";
		}
		logger.warning(error);
		trace(error);
	}
}
function clearInterval(intervalID) {
	if (intervalID != null) {
		intervalID.cancel();
	} else {
		var error = "Error in clearInterval: Not intervalID was passed in.";
		logger.warning(error);
		trace(error);
	}
}
function random(num) {
	return Math.floor(num*Math.random());
}
function readFile(filePath) {
	var helper = Plugin.getPluginHelper();
	return helper.readFile(filePath);
}
function writeFile(filePath, content, append) {
	if (append != true) {
		append = false;
	}
	var helper = Plugin.getPluginHelper();
	helper.writeFile(filePath, content, append);

}
function doesFileExist(path) {
	var helper = Plugin.getPluginHelper();
	return helper.doesFileExist(path);

}
function isFile(path) {
	var helper = Plugin.getPluginHelper();
	return helper.isFile(path);

}
function deleteFile(path) {
	var helper = Plugin.getPluginHelper();
	helper.deleteFile(path);

}
function createDirectory(path) {
	var helper = Plugin.getPluginHelper();
	return helper.createDirectory(path);
}
function deleteDirectory(path) {
	var helper = Plugin.getPluginHelper();
	return helper.deleteDirectory(path);
}
function isDirectory(path) {
	var helper = Plugin.getPluginHelper();
	return helper.isDirectory(path);
}
function doesDirectoryExist(path) {
	var helper = Plugin.getPluginHelper();
	return helper.doesDirectoryExist(path);
}
function SharedObject() {
}
SharedObject = new Object();
SharedObject.getLocal = function (name, location) {
	trace("get local")
	if (location == undefined) {
		location = "";
	}
	var file = location + name + ".txt";
	if(doesFileExist(file) == false) {
		var ob = new Object();
		ob.scores = new Array();
		var ser = new Serializer();
		var str = ser.serialize(ob);
		writeFile(file, str);
	}
	var str = readFile(file);
	var ser = new Serializer();
	var data = ser.unserialize(str);
	var ob = wrapSO(data, file);
	return ob;
};
function wrapSO(info, file) {
	var ob = new Object();
	ob.data = info;
	ob.file = file;
	ob.flush = function () {
		trace("flush called");
		var ser = new Serializer();
		var str = ser.serialize(this.data);
		writeFile(this.file, str);
	}
	ob.remove = function () {
		deleteFile(this.file);
	}
	return ob;
}
server = new serverAS();
logger = new loggerAS();
//"http://www.electrotank.com/junk/loadVarsTest.aspx"
function loadVars() {
	this.refName = 0;
}
loadVars.prototype.load = function(url) {
	if (this.refName instanceof String) {
		var name = this.refName;
	} else {
		var id = ++loadVarsContainer.id;
		var name = "LoadVars"+id;
	}
	loadVarsContainer[name] = new Object();
	loadVarsContainer[name].onLoad = this.onLoad;
	loadVarsContainer[name].owner = this;
	loadVarsContainer[name].Method = "Get";
	this.refName = name;
	// Create the configuration
	config = new java.util.HashMap();
	config.put("Url", url);
	config.put("CallID", id.toString());
	config.put("Callback", "loadVarsCallback");
	config.put("Method", "Get");
	// Actually start it going
	Plugin.loadVars(config);
};
loadVars.prototype.sendAndLoad = function(url, destOb) {
	if (this.refName instanceof String) {
		var name = this.refName;
	} else {
		var id = ++loadVarsContainer.id;
		var name = "LoadVars"+id;
	}
	loadVarsContainer[name] = new Object();
	loadVarsContainer[name].onLoad = this.onLoad;
	loadVarsContainer[name].owner = this;
	loadVarsContainer[name].Method = "Post";
	loadVarsContainer[name].destOb = destOb;
	this.refName = name;
	// Make the hash map of variables to post
	variables = new java.util.HashMap();
	this.extra = "a";
	for (var i in this) {
		if (i != "load" && i != "sendAndLoad" && i!="onLoad" && i != "refName"){
			variables.put(i, this[i]);
		}
	}
	//
	// Create the configuration
	config = new java.util.HashMap();
	config.put("Url", url);
	config.put("CallID", id.toString());
	config.put("Callback", "loadVarsCallback");
	config.put("Method", "Post");
	config.put("Variables", variables);
	// Actually start it going
	Plugin.loadVars(config);
};
function loadVarsCallback(success, other, CallID) {
	if (success) {
		var id = other.get("CallID");
	} else {
		var id = CallID;
	}
	var name = "LoadVars"+id;
	var owner = loadVarsContainer[name];
	if (success) {
		set = other.keySet();
		iterator = set.iterator();
		var ob = new Object();
		if (owner.Method == "Get") {
			while(iterator.hasNext()) {
				var tempName = iterator.next();
				var tempValue = other.get(tempName);
				owner[tempName] = tempValue;
			}
			owner.onLoad(true);
		} else if (owner.Method == "Post") {
			var destOb = owner.destOb;
			while(iterator.hasNext()) {
				var tempName = iterator.next();
				var tempValue = other.get(tempName);
				destOb[tempName] = tempValue;
			}
			destOb.onLoad(true)
		}
	} else {
		if (owner.Method == "Get") {
			owner.onLoad(false, other);
		} else if (owner.Method == "Post") {
			owner.destOb.onLoad(false, other);
		}
	}
}
LoadVars = loadVars;
loadVarsContainer = new Object();
loadVarsContainer.id = 0;
//==================================================================
//  Serializer
//==================================================================
function length(str) {
	var st = str.toString();
	return st.length;
}
Serializer = function () {
	this.__init__ ();
}
Serializer.prototype.__init__ = function () {
	this._$serializedString, this._$unserializedString = new String ();
};
Serializer.prototype.unserialize = function ($string, debug) {
	if (!debug) {
		this._$debug = false;
	}
	this._$unserializedString = this.$_getValue (unescape ($string))[0];
	return this._$unserializedString;
};
Serializer.prototype.$_getNext = function ($string) {
	var value, data;
	value = this.$_getValue ($string);
	$string = value[1];
	data = this.$_getValue ($string);
	$string = data[1];
	return [value[0], data[0], $string];
};
Serializer.prototype.$_getValue = function ($string) {
	var type, len, a, b;
	$string = new String($string); // added to double string speed
	type = $string.charAt (0);
	switch (type) {
	case 's' :
		len = $string.substr (2, $string.indexOf (':', 3) - 2) * 1;
		a = ($string.substr (length (len) + 4, len)).toString ();
		// ** cast into a string **
		break;
	case 'i' :
		len = $string.substr (2, $string.indexOf (';', 3) - 2) * 1;
		a = parseInt (len);
		// ** cast into an integer **
		break;
	case 'd' :
		len = $string.substr (2, $string.indexOf (';', 3) - 2) * 1;
		a = parseFloat (len);
		// ** cast into a float **
		break;
	case 'b' :
		len = $string.substr (2, $string.indexOf (';', 3) - 2) * 1;
		a = ((len == "true") || (len == "1")) ? true : false;
		// ** cast into a boolean **
		break;
	case 'O' :
		var delim1 = $string.indexOf (':', $string.indexOf (':') + 1) + 2;
		len = $string.substr (2, $string.indexOf (':', 3) - 2) * 1;
		/**
		 * instead of instantiating a new "Object" each time,
		 * now the object instantiated is determined by "_classtype"
		 * thus a new instance of ANY type of objects can now be 
		 * unserialized, and the result will be the SAME serialized object
		 * NB: the _class_ property of that object MUST be the same as the class name
		 * but if the _class_ was not a valid class a new "Object" will be instantiated
		 */
		var _classtype = $string.substr (delim1, len);
		_classtype = _classtype.substr(0,1).toUpperCase()+_classtype.substr(1);
		var ct = _classtype.toLowerCase();
		if (ct == "object") {
			a = new Object();
		}
		//a = new [_classtype] ();
		a = a ? a : new Object ();
		$string = $string.substr (length ($string.substr (length (len) + 4, len)) + $string.indexOf ($string.substr (length (len) + 4, len)) + 2);
		var objectLength = ($string.substr (0, $string.indexOf (':'))) * 1;
		var counter = 0;
		$string = $string.substr ($string.indexOf (':') + 2);
		while (counter < objectLength) {
			var value = this.$_getNext ($string);
			$string = value[2];
			a[value[0]] = value[1];
			counter++;
		}
		return [a, $string.substr ($string.indexOf ("}") + 1)];
	case 'a' :
		len = $string.substr (2, $string.indexOf (':', 3) - 2) * 1;
		a = new Array ();
		$string = $string.substr ($string.indexOf (len));
		var objectLength = ($string.substr (0, $string.indexOf (':'))) * 1;
		var counter = 0;
		$string = $string.substr ($string.indexOf (':') + 2);
		while (counter < objectLength) {
			var value = this.$_getNext ($string);
			$string = value[2];
			a[value[0]] = value[1];
			counter++;
		}
		return [a, $string.substr ($string.indexOf ("}") + 1)];
	case 'N' :
		a = null;
		$string = $string.substr (1);
	}
	if (type != "s") {
		len = length (len.toString ());
	}
	$string = $string.substr ($string.indexOf (";", len) + 1);
	return [a, $string];
};
Serializer.prototype.serialize = function (v) {
	if (v == undefined) {
		return null;
	}
	this._$serializedString = this.$_parseValue (v);
	return escape (this._$serializedString);
};
Serializer.prototype.$_parseValue = function(v, ret) {
	var counter = 0;
	var arrayValue = "";
	if (!isNaN(v) && v.__proto__ != Date.prototype && v.__proto__ != Boolean.prototype && v.__proto__ != String.prototype) {
		v = Number(v);
	}
	switch (v.__proto__) {
	case Array.prototype :
		for (var a in v) {
			var name = this.$_parseValue(a);
			var value = this.$_parseValue(v[a]);
			arrayValue += name.toString() + value;
			counter++;
		}
		return "a:"+counter+":{"+arrayValue+"}";
	case undefined :
		// ** variables (and elements in arrays) in flash can be 'undefined' **
	case String.prototype :
	case Date.prototype :
	case Function.prototype :
		return "s:"+length(v)+":\""+(v)+"\";";
	case Number.prototype :
		if (v%1 == 0) {
			return "i:"+v+";";
		}
		return "d:"+v+";";
	case Boolean.prototype :
		return "b:"+(v == true ? 1 : 0)+";";
	case Object.prototype :
	default :
		if (typeof v == "object") {
			for (var a in v) {
				var name = this.$_parseValue(a);
				var value = this.$_parseValue(v[a]);
				arrayValue += name.toString() + value;
				counter++;
			}
			var type = typeof v;
			return "O:"+type.length+":\""+type+"\":"+counter+":{"+arrayValue+"}";
		} else {
			return null;
		}
	}
};

//==================================================================
//  End Serializer
//==================================================================
function getUsersInRoom(zone, room) {
	var results = new Array();
	var helper = Plugin.getPluginHelper();
	var users = helper.getUsersInRoom(zone, room);
	for (var i=0;i<users.length;++i) {
		var user = users[i];
		results.push({Name:user.getName()});
	}
	return results;
}
function getRoomsInZone(zone) {
	var results = new Array();
	var helper = Plugin.getPluginHelper();
	var rooms = helper.getRoomsInZone(zone);
	for (var i=0;i<rooms.length;++i) {
		var room = rooms[i];
		results.push({Name:room.getName(), hidden:room.isHidden()});
	}
	return results;
}
function getAllZones() {
	var results = new Array();
	var helper = Plugin.getPluginHelper();
	var zones = helper.getAllZones();
	for (var i=0;i<zones.length;++i) {
		var zone = zones[i];
		results.push({Name:zone.getName()});
	}
	return results;
}
function createRoomVariable(name, value, locked) {
	if (locked == undefined) {
		locked = false;
	}
	var helper = Plugin.getPluginHelper();
	var zoneName = helper.getZoneName();
	var roomName = helper.getRoomName();
	var success = helper.createRoomVariable(zoneName, roomName, locked, name, value);
	return success;
}
function updateRoomVariable(name, value, locked) {
	if (locked == undefined) {
		locked = false;
	}
	var helper = Plugin.getPluginHelper();
	var zoneName = helper.getZoneName();
	var roomName = helper.getRoomName();
	var success = helper.createRoomVariable(zoneName, roomName, locked, name, value);
	return success;
}
function deleteRoomVariable(name) {
	var helper = Plugin.getPluginHelper();
	var zoneName = helper.getZoneName();
	var roomName = helper.getRoomName();
	var success = helper.deleteRoomVariable(zoneName, roomName, name);
	return success;
}
function getRoomVariables(zoneName, roomName) {
	var helper = Plugin.getPluginHelper();
	if (zoneName == undefined || roomName == undefined) {
		zoneName = helper.getZoneName();
		roomName = helper.getRoomName();
	}
	var roomVars = helper.getRoomVariables(zoneName, roomName);
	var arr = new Array();
	for (var i = 0; i<roomVars.length; ++i) {
		var ob = new Object();
		var roomVar = roomVars[i];
		ob.name = roomVar.getName();
		ob.value = roomVar.getValue();
		ob.locked = roomVar.isLocked();
		ob.persistent = roomVar.isPersistent();
		arr.push(ob);
	}
	return arr;
}
function getUserVariables(user) {
	var helper = Plugin.getPluginHelper();
	var userVars = helper.getUserVariables(user);
	var arr = new Array();
	for (var i = 0; i<userVars.length; ++i) {
		var ob = new Object();
		var userVar = userVars[i];
		ob.name = userVar.getName();
		ob.value = userVar.getValue();
		arr.push(ob);
	}
	return arr;
}
function createUserVariable(user, name, value) {
	var helper = Plugin.getPluginHelper();
	helper.createUserVariable(user, name, value);
}
function updateUserVariable(user, name, value) {
	var helper = Plugin.getPluginHelper();
	helper.updateUserVariable(user, name, value);
}
function deleteUserVariable(user, name) {
	var helper = Plugin.getPluginHelper();
	helper.deleteUserVariable(user, name);
}
function getZoneName() {
	var helper = Plugin.getPluginHelper();
	return helper.getZoneName();
}
function getRoomName() {
	var helper = Plugin.getPluginHelper();
	return helper.getRoomName();
}

function isUserLoggedIn(name) {
    var helper = Plugin.getPluginHelper();
    return helper.isUserLoggedIn(name);
}
//=+~=+~=+~=+~=+~=+~=+~=+~=+~
//=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~=+~

